#!/bin/bash
#

_version="01.01.03"
_date="24.02.2019"

urlp=""	#url и port прокси сервера
url=""
lurlp=""
lurl=""

www_aut=""
proxy_aut=""
str=""

#
_url=""

#файл настройки прокси
_fproxy="setproxy.txt"
_proxy=""
_strproxy=""

#
_fuseragent="setuseragent.txt"
_useragent=""
_struseragent=""
_defuseragent="Mozilla/3.04 (Win95; U)"

#
_fcookies="cookies.txt"
_cookies=""

#
function fhelp()
{
	echo ""
	echo "$0 help             - текущая подсказка"
	echo "$0 version          - дата последнего изменения и версия скрипта"
	echo ""
	echo "$0 setproxy         - настройка доступа черех прокси-сервер"
	echo "$0 rmproxy          - удаление настроек прокси-сервера"
	echo "$0 setuseragent     - настройка USER AGENT \"названия\" \"вашего\" браузера"
	echo "$0 rmuseragent      - удаление  USER AGENT \"названия\" \"вашего\" браузера"
	echo "$0 cookieson        - включить cookies (файл $_fcookies создаётся)"
	echo "$0 cookiesoff       - выключить cookies (файл $_fcookies удаляется)"
	echo ""
	echo "$0 test             - тест доступа к странице"
	echo "$0 readconsole      - вывод страницы в консоль"
	echo "$0 readfile         - вывод страницы в файл"
	echo ""
}

#версия 
function fversion()
{
	echo "Date:$_date Version:$_version"
}

#доступ к прокси
function passproxy()
{
	echo ""
	echo "для прокси нужна авторизация !"
	echo -n "(пользователь:пароль)? "
	read proxy_aut
	lurlp="$proxy_aut@$urlp"
}

#доступ к прокси
function passpage()
{
	echo ""
	echo "для страницы нужна авторизация !"
	echo -n "(пользователь:пароль)? "
	read proxy_aut
	lurl="$proxy_aut@$url"
}

#первый запуск - настройка связи
function start1()
{
	echo ">>> Тест доступа к web-странице <<<"
	echo -n "URL прокси(url:port) ?:"
	read urlp
	if [ "$urlp" == "" ]; then
		echo "так значит без прокси..."
		lurlp=""
		_proxy="0"
	else
		lurlp=$urlp
		_proxy="1"
	fi
	#
	echo -n "URL страницы(url:port) ? "
	read url
	lurl=$url
	while [ 1 = 1 ]; do
		if [ "$urlp" == "" ]; then
			str=$(curl -L -k -s -I $lurl)
		else
			str=$(curl -L -k -s -I $_proxy $lurl)
		fi
		echo "Параметры узла(узлов):"
		echo "$str"
		pwstr=$(echo "$str" | grep "Proxy-Authenticate:")
		if ! [ "$pwstr" == "" ]; then
			passproxy
		else
			wstr=$(echo "$str" | grep "WWW-Authenticate:")
			if ! [ "$wstr" == "" ]; then
				passpage
			else
				break
			fi
		fi
	done

	echo -n "Запросить страницу (y - да) ?:"
	read cmd
	if [ "$cmd" == "y" ]; then
		if [ "$urlp" == "" ]; then
			str=$(curl -L -k -s $lurl)
		else
			str=$(curl -L -k -s -x $lurlp $lurl)
		fi
		strn=$(echo "$str" | sed "s/>/>\n/g")
		echo -e "$strn"
	fi

}

function fhref()
{
	echo -n "выделить ссылки (y - да) ?: "
	read cmd

	if [ "$cmd" == "y" ]; then
		_hrefs=$(echo "$strn" | grep "href=" | grep "/")
		echo "$_hrefs"
		echo ""
		echo -n "Выделить URL (y -да) ?: "
		read cmd
		if [ "$cmd" == "y" ]; then
			_urls=$(echo "$_hrefs" | sed "s/\"/\n/g")
			_urls=$(echo "$_urls" | grep "/")
			echo "$_urls"
		fi
	fi
}

function fscr()
{
	echo -n "выделить изображения (y - да) ?: "
	read cmd

	if [ "$cmd" == "y" ]; then
		_scr=$(echo "$strn" | grep "scr=")
		echo "$_scr"
	fi
}


########################

#тест доступа к странице
function ftest()
{
	echo -e "Введите URL: "
	read _url
	curl -I -L -k $_cookies $_struseragent $_strproxy $_url
}

function frdconsole()
{
	echo -e "Введите URL: "
	read _url
	curl -L -k $_cookies $_struseragent $_strproxy $_url
}

function frdfile()
{
	echo -e "Введите URL: "
	read _url
	echo -e "Введите имя файла для сохранения: "
	read nfile 
	str=$(curl -L -k $_cookies $_struseragent $_strproxy $_url)
	echo $str > $nfile
}

#######################################
#настройка прокси
function fsetproxy()
{
	echo "Введите параметры доступа через прокси вида:"
	echo -n "{user:password@url:port}: "
	read _proxy
	echo $_proxy > $_fproxy 
}

#удаление параметров прокси
function frmproxy()
{
	rm -f $_fproxy
}

#чтение параметров прокси
function frdproxy()
{
	if [ -f $_fproxy ]; then
		str=$(cat $_fproxy)
		_strproxy="-x $str"
	else
		_strproxy=""
	fi
}

############################################
#настройка user_agent
function fsetuseragent()
{
	echo -n "Применить USER AGENT по умолчанию ($_defuseragent) (y - да): "
	read str
	if [ "$str" = "y" ]; then
		str=$_defuseragent
	else
		echo -n "Введите строку USER AGENT: "
		read str
	fi
	echo $str > $_fuseragent 
}

#удаление user_agent
function frmuseragent()
{
	rm -f $_fuseragent
}

#чтение user agent
function frduseragent()
{
	if [ -f $_fuseragent ]; then
		_useragent=$(cat $_fuseragent)
		_struseragent="-A '$_useragent'" 
	else
		_struseragent=""
	fi
}

########################
function fcookieson()
{
	echo "" > $_fcookies 
}

function fcookiesoff()
{
	rm -f $_fcookies 
}

function fcookiesrd()
{
	if [ -f $_fcookies ]; then
		_cookies="-c $_fcookies"
	else
		_cookies=""
	fi
}


######################
# начало работы
######################
case $1 in
	version)
		fversion
	;;
	test)
		frdproxy
		frduseragent
		fcookiesrd
		ftest
	;;
	readconsole)
		frdproxy
		frduseragent
		fcookiesrd
		frdconsole
	;;
	readfile)
		frdproxy
		frduseragent
		fcookiesrd
		frdfile
	;;
	mantest)
		start1
		fhref
		fscr
	;;
	setuseragent)
		fsetuseragent
	;;
	rmuseragent)
		frmuseragent
	;;
	setproxy)
		fsetproxy
	;;
	rmproxy)
		frmproxy
	;;
	cookieson)
		fcookieson
	;;
	cookiesoff)
		fcookiesoff
	;;
	help)
		fhelp
	;;
	*)
		echo "$0 help  - для подсказки"
	;;
esac



